package ie.ucd.csi.comp10050.cellular_automata;

/**
 * The fundamental unit of a cellular automata.
 *
 * @author Joe Kiniry (kiniry@ucd.ie)
 * @module COMP 10050
 * @organisation School of Computer Science and Informatics
 * @copyright University College Dublin
 * @version 5 April 2006
 */

public class BasicCellKey extends BasicCell {
  /**
   * The value of this basic cell.
   */
  private boolean my_value;

  // @bon query

  /** {@inheritDoc} */
  public final boolean validValue(final long the_value) {
    return (the_value <= 1);
  }

  /** {@inheritDoc} */
  public final long validValueCount() {
    return 2;
  }

  /** {@inheritDoc} */
  public final char textualRepresentation() {
    if (value() == 0)
      return ' ';
    if (value() == 1)
      return '*';
    return 0; //@ nowarn Reachable;
  }

  /** {@inheritDoc} */
  public final long value() {
    if (my_value)
      return 1;
    else return 0;
  }

  /** {@inheritDoc} */
  public final boolean equals(final /*@ nullable */ Object a_cell) {
    final BasicCellKey temp_cell = (BasicCellKey)a_cell;
    return (temp_cell.value() == this.value());
  }

  // @bon command

  /** {@inheritDoc} */
  public final void setValue(final long the_value) {
    if (the_value == 0)
      my_value = false;
    else my_value = true;
  }

  // @bon constraint
}
